# Designed December 2009 by C.plassais + Pilou

# Permission to use this software for any purpose and without fee is hereby granted
# Distribution of this software for commercial purpose is forbidden:

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------
# Name			:   Eclate_Deplace
# Original Date	:  03 Juil 2009 version 0.0 (thx to TIG, Thomthom)
# Type			:   Plugin
# Description	:   Exploding movements of groups or/and components 
# Usage			:   Right Click - Context Menu
# Version 0.3.1 English
#---------------------------------------------------------------------------------------
#petit plug d'"explosion dplacement" de groupes ou de composants

require 'sketchup.rb'
def pilou_explose
model = Sketchup.active_model
entities = model.entities
selection = model.selection
ss = selection

    if selection.empty?
    UI.messagebox "Please select Components\nor Groups"
    end
    
model.start_operation "Deplacement Eclate"
group = model.active_entities.add_group(ss)
center1 = group.bounds.center
entities.add_cpoint(center1)
result = UI.messagebox "Do you want an orignal's copy", MB_YESNO
    if result == 6
        group2 = group.copy
        group2.explode
    end
selection = group.explode
xp = center1[0].to_i   # dtermination 
yp = center1[1].to_i  # du centre de
zp = center1[2].to_i   # la slection
prompts = ["Move away Center/against pivot", "Move pivot x", "Move pivot y", "Move pivot z", "Translation's Coef x >= 0", "Translation's Coef y >= 0", "Translation's Coef z >= 0", "Group Component Both"]
values = ["Center", xp, yp, zp, 1.00, 1.00, 1.00, "Both"]
list = ["Center|Move away", "", "", "", "", "", "" , "Group|Component|Both"]
results = UI.inputbox prompts, values, list, "Parametres"
return if not results
piv, xpn, ypn, zpn, qx, qy, qz, gc = results

    if model.options["UnitsOptions"]["LengthUnit"]==0
        
        qx = qx.to_f.inch # Translation sur l'axe x
        qy = qy.to_f.inch  # Translation sur l'axe y
        qz = qz.to_f.inch  # Translation sur l'axe z
        # xpn = xpn.inch
        # ypn = ypn.inch
        # zpn = zpn.inch
        # xp = xp.inch
        # yp = yp.inch
        # zp = zp.inch
        
    end
    
    if model.options["UnitsOptions"]["LengthUnit"]==1

        qx = qx.to_f.feet # Translation sur l'axe x
        qy = qy.to_f.feet  # Translation sur l'axe y
        qz = qz.to_f.feet  # Translation sur l'axe z
        # xpn = xpn.feet
        # ypn = ypn.feet
        # zpn = zpn.feet
        # xp = xp.feet
        # yp = yp.feet
        # zp = zp.feet
        
    end
    
    if model.options["UnitsOptions"]["LengthUnit"]==2
        
        qx = qx.to_f.mm # Translation sur l'axe x
        qy = qy.to_f.mm  # Translation sur l'axe y
        qz = qz.to_f.mm  # Translation sur l'axe z
        # xpn = xpn.mm
        # ypn = ypn.mm
        # zpn = zpn.mm
        # xp = xp.mm
        # yp = yp.mm
        # zp = zp.mm
          
    end
    
    if model.options["UnitsOptions"]["LengthUnit"]==3
        
        qx = qx.to_f.cm # Translation sur l'axe x
        qy = qy.to_f.cm # Translation sur l'axe y
        qz = qz.to_f.cm # Translation sur l'axe z
        # xpn = xpn.cm
        # ypn = ypn.cm
        # zpn = zpn.cm
        # xp = xp.cm
        # yp = yp.cm
        # zp = zp.cm
                
    end
    
    if model.options["UnitsOptions"]["LengthUnit"]==4
        
        qx = qx.to_f.m/100 # Translation sur l'axe x
        qy = qy.to_f.m/100  # Translation sur l'axe y
        qz = qz.to_f.m/100  # Translation sur l'axe z
        # xpn = xpn.m
        # ypn = ypn.m
        # zpn = zpn.m
        # xp = xp.m
        # yp = yp.m
        # zp = zp.m
                
    end 

entities.add_cpoint [xpn,ypn,zpn]
entities.add_cline [xp, yp, zp],[xpn, ypn, zpn]

    if piv =="Move away"
    xpd =  xp-xpn  # Calcul de la distance entre
    ypd =  yp-ypn  # le centre d'origine de la slection
    zpd =  zp-zpn  # et le nouveau (=0 si aucun changement)
    entities.add_cpoint [(xp+xpd), (yp+ypd), (zp+zpd)]
    entities.add_cline [xp, yp, zp],[(xp+xpd), (yp+ypd), (zp+zpd)]
    else
    xpd =  xpn-xp  # Calcul de la distance entre
    ypd =  ypn-yp  # le centre d'origine de la slection
    zpd =  zpn-zp  # et le nouveau (=0 si aucun changement)
    entities.add_cpoint [xpn,ypn,zpn]
    entities.add_cline [xp, yp, zp],[xpn, ypn, zpn]
    end
   
	if gc == "Group"
    	gc = Sketchup::Group
    	cc = Sketchup::Group
	elsif gc == "Component"
    	gc = Sketchup::ComponentInstance
    	cc = Sketchup::ComponentInstance
	elsif gc == "Both"
    	gc = Sketchup::Group
    	cc = Sketchup::ComponentInstance	
	end

	selection.each do |e| # dbut de la boucle de dplacement des objets

	next unless (e.is_a? gc) or next unless(e.is_a? cc)
	center = e.bounds.center
	xc = center[0].to_i  # Determination 
	yc = center[1].to_i  # du centre
	zc = center[2].to_i  # de l'objet
	
    entities.add_cpoint [xc, yc, zc]
    	
	xpc = xc-xp   # Calcul de la distance
	ypc = yc-yp   # entre le centre d'origine
	zpc = zc-zp   # et le centre de l'objet

	if xc==xp
    xe = xpd
    else
    xe = (xpc*qx)+xpd
    end

    if yc==yp
    ye = ypd 
    else
    ye = (ypc*qy)+ypd
    end

    if zc==zp
     ze = zpd 
    else
    ze = (zpc*qz)+zpd
    end
   	
	point = Geom::Point3d.new xe,ye,ze
	t = Geom::Transformation.new point
	e.transform!(t)
	model.selection.add e

	end	
model.commit_operation

end

	if( not file_loaded?("Eclate_Deplace.rb") )
	UI.add_context_menu_handler do |context_menu|
	context_menu.add_separator
	context_menu.add_item("Eclate_Deplace") { pilou_explose }
	end
	file_loaded("Eclate_Deplace.rb")
	end